function get_days_struct_array, dataFilePath, structToUse
    HEADER_LENGTH = 32

    useSecond1996Field = 0
    useSecond1996MinorFrame0Field = 0
    useBinStartField = 0
    structName = strlowcase(tag_names(structToUse, /STRUCTURE_NAME))
    if (strpos(structName, 'browse') GE 0) then useBinStartField = 1	    $
    else if (strpos(structName, 'commandtable') GE 0) then		    $
					useSecond1996MinorFrame0Field = 1   $
    else if (strpos(structName, 'diagnosticevent') GE 0) then		    $
					useSecond1996MinorFrame0Field = 1   $
    else useSecond1996Field = 1

	; what if data file does not exist?
    if (file_exists(dataFilePath) EQ 0) then begin
	; print, 'FLAG: ', dataFilePath, ' does not exist.  No data that day?'
	    ; return a struct array whose only member is zeroed
	structArray = replicate(structToUse, 1)
	return, structArray
    endif

    ;structArray = replicate(structToUse, structsInFileCount)

    get_lun, lun
    openr, lun, dataFilePath

	; an assoc is used instead of readu because all structs are
	; padded out to an int address when written if they aren't
	; an integral number of int lenghts long.  assoc understands
	; this and takes care of it automatically.

    structsInFileCount = get_files_struct_count(dataFilePath, structToUse)
    fileAssoc = assoc(lun, replicate(structToUse, structsInFileCount),	$
							HEADER_LENGTH)
    structArray = fileAssoc[0]

    close, lun
    free_lun, lun

    if (useSecond1996Field) then					    $
		indexes = where(structArray.Second1996 NE 0)		    $
    else if (useSecond1996MinorFrame0Field) then			    $
		indexes = where(structArray.Second1996MinorFrame0 NE 0)	    $
    else if (useBinStartField) then					    $
		indexes = where(structArray.bin_start NE 0)

    structArray = structArray(indexes)
    structArray = [structArray, structToUse]

    return, structArray
end
